from airflow.hooks.base_hook import BaseHook
from airflow.utils.session import provide_session
from airflow.models import Connection

@provide_session
def create_spark_connection(session=None):
    # Define the Spark connection parameters
    conn_id = "spark_standalone"
    conn_type = "spark"
    host = "spark://spark-master:7077"
    schema = "spark"
    extra = '{"queue": "default"}'

    # Check if the connection already exists
    existing_conn = session.query(Connection).filter(Connection.conn_id == conn_id).first()

    if existing_conn:
        print(f"Connection with ID {conn_id} already exists.")
    else:
        # Create a new Spark connection
        new_conn = Connection(
            conn_id=conn_id,
            conn_type=conn_type,
            host=host,
            schema=schema,
            extra=extra,
        )
        session.add(new_conn)
        session.commit()
        print(f"Connection {conn_id} created successfully.")

# Call the function to create the connection
if __name__ == "__main__":
    create_spark_connection()
